Autodesk官方最新的.NET教程(三)(vb.net版)

原创 2005年06月02日 11:11:00

 

3   数据库基础:  创建我们自己的Employee 对象

 

打开Lab3文件夹下的Lab3工程文件,或或接着Lab2的代码。

在这一章中,我们将创建一个‘Employee 对象(包括一个圆,一个椭圆和一个多行文本对象),这个对象属于一个自定义的EmployeeBlock’块(这个块驻留在‘EmployeeLayer’层,当在模型空间插入这个块的时候,‘EmployeeLayer’层就会拥有这个块的一个块索引)。本章的每一个步骤中的代码都可以运行,这样做的目的可以使你更清楚地知道每一部分代码完成的功能。一步将简要说明一下如何在模型空间创建一个圆。

 

 

这一章的重点是在AutoCAD中访问数据库的基础。主要内容包括事务处理(Transaction)、对象IdObjectId)、符号表(symbol tables,如块表BlockTable和层表LayerTable)以及对象引用。使用的其它一些对象如颜色Color、三维点Point3d和三维向量Vector3d,都和各自的步骤有关,但重点应该放在数据库基础上。

1)    创建一个名为‘CREATE’的命令,它调用函数CreateEmployee()。这个函数用来在模型空间(MODELSPACE)的(10100)点处创建一个半径为2.0的圆:

 

<CommandMethod("CREATE")> _

Public Function CreateEmployee()

首先声明我们要使用的对象

Dim circle As Circle 这个是我们要加入到模型空间的圆

Dim btr As BlockTableRecord 要加入圆,我们必须打开模型空间

Dim bt As BlockTable 要打开模型空间,我们必须通过块表(BlockTable)来访问它

 

 我们使用一个名为‘Transaction’的对象,把函数中有关数据库的操作封装起来

Dim trans As Transaction

 

使用TransactionManagerStartTransaction()成员来开始事务处理

trans = HostApplicationServices.WorkingDatabase().TransactionManager.StartTransaction()

现在创建圆……请仔细看这些参数——注意创建Point3d对象的‘New’Vector3d的静态成员ZAxis

circle =

New Circle
(New Point3d(10, 10, 0), Vector3d.ZAxis, 2.0)

 

我们需要获得块表和模型空间对象

注意我们是用事务处理的成员GetObject来获取它们的bt = trans.GetObject(HostApplicationServices.WorkingDatabase.BlockTableId, OpenMode.ForRead)

现在,我们声明了一个ObjectId对象用来表示模型空间块表记录

Dim btrId As ObjectId = bt.Item(btr.ModelSpace)

使用这个ObjectId对象来获取块表记录对象注意我们是打开它用来写入

btr = trans.GetObject(btrId, OpenMode.ForWrite)

 

现在使用btr对象来加入圆

btr.AppendEntity(circle)

trans.AddNewlyCreatedDBObject(circle, True) 并确定事务处理知道要加入圆!

 

trans.Commit() 一旦完成以上操作,我们就提交事务处理,这样以上所做的改变就被保存了……

trans.Dispose() ’ …然后销毁事务处理,因为我们已经完成了相关的操作(事务处理不是数据库驻留对象,可以销毁)

End Function

 

请仔细阅读一下上面的代码块的结构,可以通过注释来了解相关的细节。

注意:要编译代码,你必须导入Autodesk.AutoCAD.DatabaseServices Autodesk.AutoCAD.Geometry命名空间

 

运行这个函数来看看它是否可行。应该会在图形中创建一个在(10,10,0)处的半径为2.0的白色的圆。

 

2)    我们可以减少代码的输入量,这可以通过声明一个Database变量代替HostApplicationServices.WorkingDatabase来实现:

       Dim db as Database = HostApplicationServices.WorkingDatabase()

 

使用这个变量来代替在代码中出现的HostApplicationServices.WorkingDatabase()

 

 

3)    注意:bt.Item(btr.ModelSpace)用来获取模型空间块表记录的ObjectId。我们也可以使用BlockTable的可数化属性来做同样的事:

 

bt(btr.ModelSpace)

 

上面的方法使代码变得容易和精简(像下面一样改变有关的代码):

 

            bt = trans.GetObject(db.BlockTableId, OpenMode.ForRead)

            btr = trans.GetObject(bt(btr.ModelSpace), OpenMode.ForWrite)

 

4)    在上面的代码中,我们没有使用任何异常处理,而异常处理对一个正确的.NET应用程序来说是非常重要的。我们要养成使用异常处理的好习惯,所以让我们在这个函数中加入Try-Catch-Finally

 

5)    为了使代码紧凑,我们可以把许多变量的声明和初始化放在同一个语句中。现在,你的代码看起来应该是这样的:

 

<CommandMethod("CREATE")> _

Public Function CreateEmployee()

Dim db As Database = HostApplicationServices.WorkingDatabase()

Dim trans As Transaction = db.TransactionManager.StartTransaction()

Try

Dim Circle As Circle = New Circle(New Point3d(10, 10, 0), Vector3d.ZAxis, 2.0)

 

Dim bt as BlockTable = trans.GetObject(db.BlockTableId, OpenMode.ForRead)

Dim btr as BlockTableRecord = trans.GetObject(bt(btr.ModelSpace), OpenMode.ForWrite)

 

btr.AppendEntity(circle)

trans.AddNewlyCreatedDBObject(circle, True)

 

trans.Commit()

Catch

MsgBox("Error Adding Entities")

Finally

trans.Dispose()

End Try

End Function

 

运行你的代码来进行测试……

上面的catch块只显示一个错误信息。实际的清理工作是在finally块中进行的。这样做的理由是如果在事务处理被提交(Commit())之前,Dispose()被调用的话,事务处理会被 销毁。我们认为如果在trans.Commit()之前出现任何错误的话,你应该销毁事务处理(因为Commit将永远不会被调用)。如果在Dispose()之前调用了Commit(),也就是说没有任何错误发生,那么事务处理将会被提交给数据库。

所以基于上面的分析,Catch块其实并不是必须的,因为它只用来通知用户程序出现了一个错误。它将在下面的代码中被去掉。

6)    现在让我们在Employee加入剩下的部分:椭圆和多行文本的实例。

现在让我们在Employee加入剩下的部分:椭圆和多行文本的实例。

       多行文本实体:

              中心点应该与圆心的创建一样:

                     (建议:创建一个名为‘center’而值为10,10,0Point3d变量来表示中心点)

              多行文本的内容可以是你的名字。

       椭圆(提示:你可以先看一下Ellipse的构造函数)

              法向量应该沿着Z轴(请查看Vector3d类型)

              主轴设为Vector3d(3,0,0)(提示:不要忘了用new

              半径比例设为0.5

              椭圆还必须闭合(也就是说,开始和结束点必须相同)

运行你的代码来进行测试……应该可以生成一个圆、一个椭圆和一个中心点在10,10,0的多行文本。

注意:和事务处理对象有关的.NET API中的Try-Catch-Finally块结构,应该是异常观察者。实际上我们是在try块中实例化对象的,但没有显式地销毁它们。当产生异常的时候可能会产生问题,特别是当观察者注意到我们实际上用的是封装的非托管对象!记住,当资源不再使用的时候,垃圾收集机制就会回收内存。垃圾收集机制会不时的调用封装类的Dispose()方法,删除非托管对象。

这里还要注意的是Dispose()作用于封装的非托管类对象的方式取决于对象是否是数据库驻留对象。由非数据库驻留对象调用的Dispose()会删除非托管对象,而由数据库驻留对象调用的Dispose()只是关闭它们。

7)         接下来让我们来创建一个新的函数,它用来新建一个颜色为黄色,名字为“EmployeeLayer” AutoCAD层。

这个函数应该检查是否这个层已经存在,但不管这个层是否存在,函数都应该返回“EmployeeLayer”ObjectId。下面是这个函数的代码:

    Public Function CreateLayer() As ObjectId

        Dim layerId As ObjectId '它返回函数的值

        Dim db As Database = HostApplicationServices.WorkingDatabase

        Dim trans As Transaction = db.TransactionManager.StartTransaction()

        '首先取得层表……

        Dim lt As LayerTable = trans.GetObject(db.LayerTableId, OpenMode.ForWrite)

 

        '检查EmployeeLayer层是否存在……

        If lt.Has("EmployeeLayer") Then

            layerId = lt.Item("EmployeeLayer")

        Else

            '如果EmployeeLayer层不存在,就创建它

            Dim ltr As LayerTableRecord = New LayerTableRecord()

            ltr.Name = "EmployeeLayer"//设置层的名字

            layerId = lt.Add(ltr)

            trans.AddNewlyCreatedDBObject(ltr, True)

        End If

        trans.Commit()

        trans.Dispose()

        Return layerId

    End Function

 

是不是觉得这个函数的基本结构与在模型空间加入实体的代码比较类似?访问数据库的方法都是这样的:使用事务处理来获取数据库对象,在符号表(模型空间所在的块表也是符号表之一)中加入实体,然后让事务处理知道。

8)    在这个函数中加入异常处理,就像在CreateEmployee函数中的一样。

 

9)    接下来,改变新建层的颜色。下面是实现的代码片断,请把它加入到你的代码中:

 

ltr.Color = Color.FromColorIndex(ColorMethod.ByAci, 2)

 

注意:ColorMethod.ByAci可以让我们使用AutoCAD ACI颜色索引……这里为2(表示黄色)。

 

10)   回到CreateEmployee(),加入把上面创建的几个实体设置到EmployeeLayer层的代码。声明一个类型为ObjectId的变量,用CreateLayer函数的返回值给它赋值。使用每个实体(文本、圆和椭圆)的LayerId属性设置它们所在的层。

例如:text.LayerId = empId

 

运行代码来查看“EmployeeLayer”是否已被创建,所有已创建的实体是否都在这一层上(应该显示为黄色)

 

11)   现在为各个实体设置不同的颜色,可以使用ColorIndex属性(ColorIndex属性表示AutoCAD的颜色)

 

       圆为红色-1

       椭圆为绿色-3

       文本为黄色-2

 

运行代码,看看实体的颜色是否为设置的值,即使这些实体是在“EmployeeLayer”层上。

 

12)   接下来,我们要在AutoCAD数据库中创建一个独立的块,然后把它插入到块表而不是模型空间中。

 

首先把CreateEmployee函数的名字改为CreateEmployeeDefinition()

加入以下代码来创建一个独立的块:

 

Dim myBtr As BlockTableRecord = New BlockTableRecord()

myBtr.Name = "EmployeeBlock"

Dim myBtrId As ObjectId = bt.Add(myBtr)

trans.AddNewlyCreatedDBObject(myBtr, True)

 

13)   现在,请稍微改动一下加入实体到模型空间的代码(改为加入块到块表中,记得加入前要打开块表)。

 

现在运行代码,然后使用INSERT命令来检查是否可以正确插入这个块。

 

14)   最后,我们要创建一个位于模型空间的块索引,它表示上面创建的块的一个实例。这一步留给大家练习。

 

下面是你要遵循的最基本的步骤:

      

A)                  创建一个名为CreateEmployee新的函数

 

B)                  把命令属性“CREATE”移动到CreateEmployee()

 

C)                  修改CreateEmployeeDefintion()来返回新创建的块“EmployeeBlock”ObjectId,操作的步骤请参考CreateLayer()的作法。

 

D)                  你需要修改CreateEmployeeDefintion()来查看块表中是否已包含“EmployeeBlock”块,如果包含这个块,则返回它的ObjectId(做法与CreateLayer()一样)。

提示:把‘bt’的声明语句移动到try块的顶部,使用BlockTable.Has()方法,把其它的代码移动到else语句:

Try

                '获取BlockTable 对象

                Dim bt As BlockTable = trans.GetObject(db.BlockTableId, OpenMode.ForWrite)

                If (bt.Has("EmployeeBlock")) Then

                newBtrId = bt("EmployeeBlock") '已经存在……没必要创建它!

Else

  

 

E)                  在新创建的CreateEmployee()函数中创建一个新的BlockReference对象,并把它加入到模型空间。提

示:我们可以使用CreateEmployeeDefinition()中引用模型空间的代码,这些代码在这里不需要了

F)                  CreateEmployee中调用CreateEmployeeDefinition()函数,使上面生成的BlockReference对象的BlockTableRecord()指向CreateEmployeeDefinition()函数。提示:请参考BlockReference的构造函数。

 

 

附加的问题:

让我们来看一下代码的运行情况,执行命令会生成一个EmployeeBlock的块索引,你会看到它被插入到20,20,0而不是10,10,0。为什么?

如果你知道原因,那么怎样才能使块索引插入到正确的点?

当你用List命令查看块索引时,它会告诉你它位于0层(或者当命令运行时位于当前层)。为什么?

怎样才能让块索引总是位于EmployeeLayer层?

 

 

 

 

 

 

 

 

 

 

Autodesk官方最新C#.net版开发教程

  • 2009年01月13日 15:29
  • 326KB
  • 下载

Autodesk官方最新的.NET教程(C#版)

  • 2008年07月29日 09:38
  • 324KB
  • 下载

流程图控件(FlowChart.Net) v6.1.3 官方免费版下载附安装教程

FlowChart.Net免费版是一款基于.net的流程图控件,主要用于帮助用户快速创建网络拓扑图、实体关系图、对象层次和关系图、算法流程图、组织结构图、类图、xml文档、工作流程图等等,内置多款模板...

Autodesk官方最新的.NET教程(C#版)

  • 2013年12月26日 21:37
  • 892KB
  • 下载

Asp.Net MVC4.0 官方教程 入门指南之三--添加一个视图

在本节中,您需要修改HelloWorldController类,从而使用视图模板文件,干净优雅的封装生成返回到客户端浏览器HTML的过程。 您将创建一个视图模板文件,其中使用了ASP.NET MVC...
  • itmaxin
  • itmaxin
  • 2014年04月03日 17:25
  • 17576

Autodesk官方最新的.NET基础教程

  • 2013年10月04日 22:52
  • 18KB
  • 下载

学习ASP .NET MVC5官方教程总结(三)添加视图

学习ASP .NET MVC5官方教程总结(三)添加视图         在上一章中我们讲了MVC中的"C",控制器Controllers,这一章我们来讲"V",视图Views,和一些"M",模型M...

Autodesk官方最新的.NET教程

  • 2009年05月14日 21:20
  • 7.2MB
  • 下载
内容举报
返回顶部
收藏助手
不良信息举报
您举报文章:Autodesk官方最新的.NET教程(三)(vb.net版)
举报原因:
原因补充:

(最多只允许输入30个字)